<!DOCTYPE html>
<html>
    <?php include_once('head.php'); ?>
    <body>
        <?php include_once('nav.php'); ?>

        <div class="content">
            <?php
            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                if (isset($_POST['remove']) && !empty($_POST['remove'])) {
                    $item = DB::queryFirstRow('SELECT * FROM items WHERE id=%d', $_POST['remove']);
                    $storage = DB::queryFirstRow('SELECT amount FROM storages WHERE id=%d', $item['storageid']);
                    $headCategory = DB::queryFirstRow('SELECT amount FROM headCategories WHERE id=%d', $item['headCategory']);
                    DB::update('storages', array('amount' => intVal($storage['amount']) - intVal($item['amount'])), 'id=%d', $item['storageid']);
                    DB::update('headCategories', array('amount' => intVal($headCategory['amount']) - intVal($item['amount'])), 'id=%d', $item['headCategory']);
                    DB::query('DELETE FROM items WHERE id=%d', $_POST['remove']);
                } else if (isset($_POST['removeStorage']) && !empty($_POST['removeStorage'])) {
                    DB::update('items', array('storageid' => NULL), 'storageid=%d', $_POST['removeStorage']);
                    DB::query('DELETE FROM storages WHERE id=%d', $_POST['removeStorage']);
                }
            }
            ?>
            <form method="POST" action="inventory.php">
            <?php
                $success = FALSE;
                if (isset($_GET['storageid']) && !empty($_GET['storageid']) && isset($_GET['itemid']) && !empty($_GET['itemid'])) {
                    $storeId = intVal($_GET['storageid']);
                    $itemId = intVal($_GET['itemid']);

                    $item = DB::queryFirstRow('SELECT id, amount, storageid FROM items WHERE id=%d', $itemId);
                    if ($item['storageid'] == $storeId) {
                        header("location: inventory.php");
                        die();
                    }

                    if ($storeId != NULL) {
                        $previousStorage = DB::queryFirstRow('SELECT id, amount FROM storages WHERE id=%d', $item['storageid']);
                        DB::update('storages', array('amount' => intVal($previousStorage['amount']) - intVal($item['amount'])), 'id=%d', $previousStorage['id']);
                    }


                    $storage = DB::queryFirstRow('SELECT id, amount FROM storages WHERE id=%d', $storeId);
                    DB::update('storages', array('amount' => intVal($storage['amount']) + intVal($item['amount'])), 'id=%d', $storage['id']);
                    DB::update('items', array('storageid' => $storage['id']), 'id=%d', $item['id']);
                    header("location: inventory.php");
                    die();
                }

                if (isset($_GET['searchValue']) && !empty($_GET['searchValue'])) {
                    $searchValue = $_GET['searchValue'];

                    $storages = DB::query('SELECT id, label, amount FROM storages', $searchValue);
                    $headCategory = DB::queryFirstRow('SELECT id FROM headCategories WHERE name LIKE %ss', $searchValue);

                    foreach ($storages as $store) {
                        if ($headCategory != null) {
                            $items = DB::query('SELECT * FROM items WHERE storageid=%d AND (headCategory=%d OR label LIKE %ss OR comment LIKE %ss OR serialnumber LIKE %ss OR subcategories LIKE %ss)', $store['id'], $headCategory['id'], $searchValue, $searchValue, $searchValue, $searchValue);
                        } else {
                            $items = DB::query('SELECT * FROM items WHERE storageid=%d AND (label LIKE %ss OR comment LIKE %ss OR serialnumber LIKE %ss OR subcategories LIKE %ss)', $store['id'], $searchValue, $searchValue, $searchValue, $searchValue);
                        }

                        printf('<div class="storage-area"><button class="btn btn-secondary smallButton" name="removeStorage" value="%d" type="submit">x</button><h4 class="text-dark">%s <span class="small">(%d Gegenstände)</span></h4><ul class="list-group">', $store['id'], $store['label'], $store['amount']);
                        echo '<li class="alert alert-info"><span class="list-span-btn"></span><span class="list-span">Gruppe</span><span class="list-span">Bezeichnung</span><span class="list-span">Anzahl</span><span class="list-span">Bemerkung</span><span class="list-span">Unterkategorien</span></li>';
                        if ($items != null) {
                            foreach($items as $item) {
                                $category = DB::queryFirstRow('SELECT id, name, amount FROM headCategories WHERE id=%d', $item['headcategory']);
                                printf('<li class="list-group-item"><button class="btn btn-secondary smallButton" name="remove" value="%d" type="submit">x</button><span class="list-span">%s</span><span class="list-span">%s</span><span class="list-span">%d</span><span class="list-span">%s</span><span class="list-span">%s</span>', $item['id'], $category['name'], $item['label'], $item['amount'],$item['comment'], $item['subcategories']);

                                printf('<div class="dropdown float-right"><select autocomplete="false" class="btn btn-primary dropdown-toggle switchStorage" value="0"  type="button" tabindex="-1" data-id="%d" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">', $item['id']);
                                echo '<option selected="selected" value="-1">Zuweisen</option>';

                                foreach ($storages as $storage) {
                                    printf('<option value="%s">%s</option>', $storage['id'], $storage['label']);
                                }
                                echo '</select></li>';
                            }


                        } else {
                            echo '<li class="list-group-item"><span>Keine Gegenstände gefunden.</span></li>';
                        }

                        echo '</ul></div>';
                    }
                } else {
                    $loseItems = DB::query('SELECT * FROM items WHERE storageid=0');
                    if ($loseItems != null) {
                        printf('<div class="storage-area"><h4 class="text-dark">Unsortiert <span class="small">(%d Gegenstände)</span></h4><ul class="list-group">', DB::affectedRows());
                        echo '<li class="alert alert-info"><span class="list-span-btn"></span><span class="list-span">Gruppe</span><span class="list-span">Bezeichnung</span><span class="list-span">Anzahl</span><span class="list-span">Bemerkung</span><span class="list-span">Unterkategorien</span></li>';

                        $storages = DB::query('SELECT id, label FROM storages');
                        foreach ($loseItems as $item) {
                            $category = DB::queryFirstRow('SELECT name,amount FROM headCategories WHERE id=%d', $item['headcategory']);
                            printf('<li class="list-group-item"><button class="btn btn-secondary smallButton" name="remove" value="%d" type="submit">x</button><span class="list-span">%s</span><span class="list-span">%s</span><span class="list-span">%d</span><span class="list-span">%s</span><span class="list-span">%s</span>', $item['id'], $category['name'], $item['label'], $item['amount'],$item['comment'], $item['subcategories']);

                            printf('<div class="dropdown float-right"><select autocomplete="false" class="btn btn-primary dropdown-toggle switchStorage" value="0"  type="button" tabindex="-1" data-id="%d" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">', $item['id']);
                            echo '<option selected="selected" value="-1">Zuweisen</option>';

                            foreach ($storages as $storage) {
                                printf('<option value="%s">%s</option>', $storage['id'], $storage['label']);
                            }
                            echo '</select></li>';
                        }

                        echo '</ul></div>';
                    }


                    $storages = DB::query('SELECT id, label, amount FROM storages');
                    if ($storages == null && $loseItems == null) {
                        echo '<div class="storage-area"><ul class="list-group"><li class="list-group-item"><span>Keine Gegenstände gefunden.</span></li></ul></div';
                    } else {
                        foreach ($storages as $store) {
                            $items = DB::query('SELECT * FROM items WHERE storageid=%d', $store['id']);
                            printf('<hr></hr><div class="storage-area"><button class="btn btn-secondary smallButton" name="removeStorage" value="%d" type="submit">x</button><h4 class="text-dark">%s <span class="small">(%d Gegenstände)</span></h4><ul class="list-group">', $store['id'], $store['label'], $store['amount']);
                            echo '<li class="alert alert-info"><span class="list-span-btn"></span><span class="list-span">Gruppe</span><span class="list-span">Bezeichnung</span><span class="list-span">Anzahl</span><span class="list-span">Bemerkung</span><span class="list-span">Unterkategorien</span></li>';

                            if ($items != null) {
                                foreach($items as $item) {
                                    $category = DB::queryFirstRow('SELECT name,amount FROM headCategories WHERE id=%d', $item['headcategory']);
                                    printf('<li class="list-group-item"><button class="btn btn-secondary smallButton" name="remove" value="%d" type="submit">x</button><span class="list-span">%s</span><span class="list-span">%s</span><span class="list-span">%d</span><span class="list-span">%s</span><span class="list-span">%s</span>', $item['id'], $category['name'], $item['label'], $item['amount'],$item['comment'], $item['subcategories']);
                                    printf('<div class="dropdown float-right"><select autocomplete="false" class="btn btn-primary dropdown-toggle switchStorage" value="0" type="button" tabindex="-1" data-id="%d" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">', $item['id']);
                                    echo '<option selected="selected" value="-1">Zuweisen</option>';

                                    foreach ($storages as $storage) {
                                        printf('<option value="%s">%s</option>', $storage['id'], $storage['label']);
                                    }
                                    echo '</select></li>';
                                }
                            } else {
                                echo '<li class="list-group-item"><span>Keine Gegenstände gefunden.</span></li>';
                            }
                            echo '</ul></div>';
                        }
                    }
                }
            ?>
            </form>
        </div>

        <?php include_once('footer.php'); ?>
        <script type="text/javascript">
            let switches = document.querySelectorAll('.btn.switchStorage')
            for (let item of switches) {
                item.addEventListener('change', function(evt) {
                    if (evt.target.value === '-1') return
                    window.location.href = 'inventory.php?storageid=' + evt.target.value + '&itemid=' + evt.target.dataset['id'];
                })
            }
        </script>
    </body>
</html>